import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _createActions2;

import { createActions } from 'redux-actions';
import { KEYS, PATHS } from './constants';
var dataKey = KEYS.DATA,
    errorKey = KEYS.ERROR;
var itemsPath = PATHS.ITEMS,
    skillsPath = PATHS.SKILLS,
    specializationsPath = PATHS.SPECIALIZATIONS,
    traitsPath = PATHS.TRAITS;
export var TYPES = {
  FETCH: 'FETCH',
  CANCEL: 'CANCEL',
  FETCH_SUCCESS: 'FETCH_SUCCESS',
  FETCH_ERROR: 'FETCH_ERROR'
};

var _createActions = createActions((_createActions2 = {}, _defineProperty(_createActions2, TYPES.FETCH, undefined), _defineProperty(_createActions2, TYPES.CANCEL, undefined), _defineProperty(_createActions2, TYPES.FETCH_SUCCESS, [function (_ref) {
  var data = _ref[dataKey];
  return data;
}, function (_ref2) {
  var id = _ref2.id,
      path = _ref2.path;
  return {
    id: id,
    path: path
  };
}]), _defineProperty(_createActions2, TYPES.FETCH_ERROR, [function (_ref3) {
  var error = _ref3[errorKey];
  return error;
}, function (_ref4) {
  var id = _ref4.id,
      path = _ref4.path;
  return {
    id: id,
    path: path
  };
}]), _createActions2)),
    fetch = _createActions.fetch,
    cancel = _createActions.cancel,
    fetchSuccess = _createActions.fetchSuccess,
    fetchError = _createActions.fetchError;

export { fetch, cancel, fetchSuccess, fetchError };
var _fetchItem$cancelItem = {
  fetchItem: function fetchItem(id) {
    return fetch({
      id: id,
      path: itemsPath
    });
  },
  cancelItem: function cancelItem(id) {
    return cancel({
      id: id,
      path: itemsPath
    });
  },
  fetchSkill: function fetchSkill(id) {
    return fetch({
      id: id,
      path: skillsPath
    });
  },
  cancelSkill: function cancelSkill(id) {
    return cancel({
      id: id,
      path: skillsPath
    });
  },
  fetchSpecialization: function fetchSpecialization(id) {
    return fetch({
      id: id,
      path: specializationsPath
    });
  },
  cancelSpecialization: function cancelSpecialization(id) {
    return cancel({
      id: id,
      path: specializationsPath
    });
  },
  fetchTrait: function fetchTrait(id) {
    return fetch({
      id: id,
      path: traitsPath
    });
  },
  cancelTrait: function cancelTrait(id) {
    return cancel({
      id: id,
      path: traitsPath
    });
  }
},
    fetchItem = _fetchItem$cancelItem.fetchItem,
    cancelItem = _fetchItem$cancelItem.cancelItem,
    fetchSkill = _fetchItem$cancelItem.fetchSkill,
    cancelSkill = _fetchItem$cancelItem.cancelSkill,
    fetchSpecialization = _fetchItem$cancelItem.fetchSpecialization,
    cancelSpecialization = _fetchItem$cancelItem.cancelSpecialization,
    fetchTrait = _fetchItem$cancelItem.fetchTrait,
    cancelTrait = _fetchItem$cancelItem.cancelTrait;
export { fetchItem, cancelItem, fetchSkill, cancelSkill, fetchSpecialization, cancelSpecialization, fetchTrait, cancelTrait };
//# sourceMappingURL=actions.js.map