import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import { fetch, cancel, fetchSuccess, fetchError } from './actions';
import { KEYS, PATHS } from './constants';
import reducer from './reducers';
var dataKey = KEYS.DATA,
    errorKey = KEYS.ERROR,
    pendingKey = KEYS.PENDING;
var expectedInitialState = Object.assign.apply(Object, _toConsumableArray(Object.values(PATHS).map(function (reducerPath) {
  return _defineProperty({}, reducerPath, {});
})));
var id = 12345;
var path = PATHS.ITEMS;
describe('reducers', function () {
  it('should return correct initial state', function () {
    expect(reducer(undefined, {})).toEqual(expectedInitialState);
  });
  describe('fetchReducer', function () {
    it('should return correct state for fetch action', function () {
      var _id;

      expect(reducer(undefined, fetch({
        id: id,
        path: path
      }))).toEqual(_objectSpread({}, expectedInitialState, _defineProperty({}, path, _objectSpread({}, expectedInitialState[path], _defineProperty({}, id, (_id = {}, _defineProperty(_id, errorKey, null), _defineProperty(_id, pendingKey, 1), _id))))));
    });
  });
  describe('cancelReducer', function () {
    it('should return correct state for cancel action', function () {
      expect(reducer(undefined, cancel({
        id: id,
        path: path
      }))).toEqual(_objectSpread({}, expectedInitialState, _defineProperty({}, path, _objectSpread({}, expectedInitialState[path], _defineProperty({}, id, _defineProperty({}, pendingKey, -1))))));
    });
  });
  describe('fetchSuccessReducer', function () {
    it('should return correct state for fetchSuccess action', function () {
      var _id3;

      var data = 'data';
      expect(reducer(undefined, fetchSuccess(_defineProperty({
        id: id,
        path: path
      }, dataKey, data)))).toEqual(_objectSpread({}, expectedInitialState, _defineProperty({}, path, _objectSpread({}, expectedInitialState[path], _defineProperty({}, id, (_id3 = {}, _defineProperty(_id3, dataKey, data), _defineProperty(_id3, errorKey, null), _defineProperty(_id3, pendingKey, -1), _id3))))));
    });
  });
  describe('fetchErrorReducer', function () {
    it('should return correct state for fetchError action', function () {
      var _id4;

      var error = {
        message: 'error'
      };
      expect(reducer(undefined, fetchError(_defineProperty({
        id: id,
        path: path
      }, errorKey, error)))).toEqual(_objectSpread({}, expectedInitialState, _defineProperty({}, path, _objectSpread({}, expectedInitialState[path], _defineProperty({}, id, (_id4 = {}, _defineProperty(_id4, dataKey, null), _defineProperty(_id4, errorKey, error.message), _defineProperty(_id4, pendingKey, -1), _id4))))));
    });
  });
});
//# sourceMappingURL=reducers.spec.js.map