import createCachedSelector from 're-reselect';
import { ROOT_REDUCER_KEY, PATHS, KEYS } from './constants';
var itemsPath = PATHS.ITEMS,
    skillsPath = PATHS.SKILLS,
    specializationsPath = PATHS.SPECIALIZATIONS,
    traitsPath = PATHS.TRAITS;
var dataKey = KEYS.DATA,
    errorKey = KEYS.ERROR,
    pendingKey = KEYS.PENDING;

var getData = function getData(_ref) {
  var data = _ref[dataKey];
  return data;
};

var getError = function getError(_ref2) {
  var error = _ref2[errorKey];
  return error;
};

var isFetching = function isFetching(_ref3) {
  var pending = _ref3[pendingKey];
  return pending > 0;
};

var isFetched = function isFetched(_ref4) {
  var data = _ref4[dataKey];
  return !!data;
};

var idCacheKey = function idCacheKey(state, _ref5) {
  var id = _ref5.id;
  return id;
};

var getItem = function getItem(_ref6, _ref7) {
  var items = _ref6[ROOT_REDUCER_KEY][itemsPath];
  var id = _ref7.id;
  return items[id] || {};
};

var getSkill = function getSkill(_ref8, _ref9) {
  var skills = _ref8[ROOT_REDUCER_KEY][skillsPath];
  var id = _ref9.id;
  return skills[id] || {};
};

var getSpecialization = function getSpecialization(_ref10, _ref11) {
  var specializations = _ref10[ROOT_REDUCER_KEY][specializationsPath];
  var id = _ref11.id;
  return specializations[id] || {};
};

var getTrait = function getTrait(_ref12, _ref13) {
  var traits = _ref12[ROOT_REDUCER_KEY][traitsPath];
  var id = _ref13.id;
  return traits[id] || {};
};

export var getItemData = createCachedSelector(getItem, getData)(idCacheKey);
export var getItemError = createCachedSelector(getItem, getError)(idCacheKey);
export var isItemFetching = createCachedSelector(getItem, isFetching)(idCacheKey);
export var isItemFetched = createCachedSelector(getItem, isFetched)(idCacheKey);
export var getSkillData = createCachedSelector(getSkill, getData)(idCacheKey);
export var getSkillError = createCachedSelector(getSkill, getError)(idCacheKey);
export var isSkillFetching = createCachedSelector(getSkill, isFetching)(idCacheKey);
export var isSkillFetched = createCachedSelector(getSkill, isFetched)(idCacheKey);
export var getSpecializationData = createCachedSelector(getSpecialization, getData)(idCacheKey);
export var getSpecializationError = createCachedSelector(getSpecialization, getError)(idCacheKey);
export var isSpecializationFetching = createCachedSelector(getSpecialization, isFetching)(idCacheKey);
export var isSpecializationFetched = createCachedSelector(getSpecialization, isFetched)(idCacheKey);
export var getTraitData = createCachedSelector(getTrait, getData)(idCacheKey);
export var getTraitError = createCachedSelector(getTrait, getError)(idCacheKey);
export var isTraitFetching = createCachedSelector(getTrait, isFetching)(idCacheKey);
export var isTraitFetched = createCachedSelector(getTrait, isFetched)(idCacheKey);
//# sourceMappingURL=selectors.js.map