"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cancelTrait = exports.fetchTrait = exports.cancelSpecialization = exports.fetchSpecialization = exports.cancelSkill = exports.fetchSkill = exports.cancelItem = exports.fetchItem = exports.fetchError = exports.fetchSuccess = exports.cancel = exports.fetch = exports.TYPES = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _reduxActions = require("redux-actions");

var _constants = require("./constants");

var _createActions2;

var dataKey = _constants.KEYS.DATA,
    errorKey = _constants.KEYS.ERROR;
var itemsPath = _constants.PATHS.ITEMS,
    skillsPath = _constants.PATHS.SKILLS,
    specializationsPath = _constants.PATHS.SPECIALIZATIONS,
    traitsPath = _constants.PATHS.TRAITS;
var TYPES = {
  FETCH: 'FETCH',
  CANCEL: 'CANCEL',
  FETCH_SUCCESS: 'FETCH_SUCCESS',
  FETCH_ERROR: 'FETCH_ERROR'
};
exports.TYPES = TYPES;

var _createActions = (0, _reduxActions.createActions)((_createActions2 = {}, (0, _defineProperty2["default"])(_createActions2, TYPES.FETCH, undefined), (0, _defineProperty2["default"])(_createActions2, TYPES.CANCEL, undefined), (0, _defineProperty2["default"])(_createActions2, TYPES.FETCH_SUCCESS, [function (_ref) {
  var data = _ref[dataKey];
  return data;
}, function (_ref2) {
  var id = _ref2.id,
      path = _ref2.path;
  return {
    id: id,
    path: path
  };
}]), (0, _defineProperty2["default"])(_createActions2, TYPES.FETCH_ERROR, [function (_ref3) {
  var error = _ref3[errorKey];
  return error;
}, function (_ref4) {
  var id = _ref4.id,
      path = _ref4.path;
  return {
    id: id,
    path: path
  };
}]), _createActions2)),
    fetch = _createActions.fetch,
    cancel = _createActions.cancel,
    fetchSuccess = _createActions.fetchSuccess,
    fetchError = _createActions.fetchError;

exports.fetchError = fetchError;
exports.fetchSuccess = fetchSuccess;
exports.cancel = cancel;
exports.fetch = fetch;
var _fetchItem$cancelItem = {
  fetchItem: function fetchItem(id) {
    return fetch({
      id: id,
      path: itemsPath
    });
  },
  cancelItem: function cancelItem(id) {
    return cancel({
      id: id,
      path: itemsPath
    });
  },
  fetchSkill: function fetchSkill(id) {
    return fetch({
      id: id,
      path: skillsPath
    });
  },
  cancelSkill: function cancelSkill(id) {
    return cancel({
      id: id,
      path: skillsPath
    });
  },
  fetchSpecialization: function fetchSpecialization(id) {
    return fetch({
      id: id,
      path: specializationsPath
    });
  },
  cancelSpecialization: function cancelSpecialization(id) {
    return cancel({
      id: id,
      path: specializationsPath
    });
  },
  fetchTrait: function fetchTrait(id) {
    return fetch({
      id: id,
      path: traitsPath
    });
  },
  cancelTrait: function cancelTrait(id) {
    return cancel({
      id: id,
      path: traitsPath
    });
  }
},
    fetchItem = _fetchItem$cancelItem.fetchItem,
    cancelItem = _fetchItem$cancelItem.cancelItem,
    fetchSkill = _fetchItem$cancelItem.fetchSkill,
    cancelSkill = _fetchItem$cancelItem.cancelSkill,
    fetchSpecialization = _fetchItem$cancelItem.fetchSpecialization,
    cancelSpecialization = _fetchItem$cancelItem.cancelSpecialization,
    fetchTrait = _fetchItem$cancelItem.fetchTrait,
    cancelTrait = _fetchItem$cancelItem.cancelTrait;
exports.cancelTrait = cancelTrait;
exports.fetchTrait = fetchTrait;
exports.cancelSpecialization = cancelSpecialization;
exports.fetchSpecialization = fetchSpecialization;
exports.cancelSkill = cancelSkill;
exports.fetchSkill = fetchSkill;
exports.cancelItem = cancelItem;
exports.fetchItem = fetchItem;
//# sourceMappingURL=actions.js.map