"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _actions = require("./actions");

var _constants = require("./constants");

var _reducers = _interopRequireDefault(require("./reducers"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var dataKey = _constants.KEYS.DATA,
    errorKey = _constants.KEYS.ERROR,
    pendingKey = _constants.KEYS.PENDING;
var expectedInitialState = Object.assign.apply(Object, (0, _toConsumableArray2["default"])(Object.values(_constants.PATHS).map(function (reducerPath) {
  return (0, _defineProperty2["default"])({}, reducerPath, {});
})));
var id = 12345;
var path = _constants.PATHS.ITEMS;
describe('reducers', function () {
  it('should return correct initial state', function () {
    expect((0, _reducers["default"])(undefined, {})).toEqual(expectedInitialState);
  });
  describe('fetchReducer', function () {
    it('should return correct state for fetch action', function () {
      var _id;

      expect((0, _reducers["default"])(undefined, (0, _actions.fetch)({
        id: id,
        path: path
      }))).toEqual(_objectSpread({}, expectedInitialState, (0, _defineProperty2["default"])({}, path, _objectSpread({}, expectedInitialState[path], (0, _defineProperty2["default"])({}, id, (_id = {}, (0, _defineProperty2["default"])(_id, errorKey, null), (0, _defineProperty2["default"])(_id, pendingKey, 1), _id))))));
    });
  });
  describe('cancelReducer', function () {
    it('should return correct state for cancel action', function () {
      expect((0, _reducers["default"])(undefined, (0, _actions.cancel)({
        id: id,
        path: path
      }))).toEqual(_objectSpread({}, expectedInitialState, (0, _defineProperty2["default"])({}, path, _objectSpread({}, expectedInitialState[path], (0, _defineProperty2["default"])({}, id, (0, _defineProperty2["default"])({}, pendingKey, -1))))));
    });
  });
  describe('fetchSuccessReducer', function () {
    it('should return correct state for fetchSuccess action', function () {
      var _id3;

      var data = 'data';
      expect((0, _reducers["default"])(undefined, (0, _actions.fetchSuccess)((0, _defineProperty2["default"])({
        id: id,
        path: path
      }, dataKey, data)))).toEqual(_objectSpread({}, expectedInitialState, (0, _defineProperty2["default"])({}, path, _objectSpread({}, expectedInitialState[path], (0, _defineProperty2["default"])({}, id, (_id3 = {}, (0, _defineProperty2["default"])(_id3, dataKey, data), (0, _defineProperty2["default"])(_id3, errorKey, null), (0, _defineProperty2["default"])(_id3, pendingKey, -1), _id3))))));
    });
  });
  describe('fetchErrorReducer', function () {
    it('should return correct state for fetchError action', function () {
      var _id4;

      var error = {
        message: 'error'
      };
      expect((0, _reducers["default"])(undefined, (0, _actions.fetchError)((0, _defineProperty2["default"])({
        id: id,
        path: path
      }, errorKey, error)))).toEqual(_objectSpread({}, expectedInitialState, (0, _defineProperty2["default"])({}, path, _objectSpread({}, expectedInitialState[path], (0, _defineProperty2["default"])({}, id, (_id4 = {}, (0, _defineProperty2["default"])(_id4, dataKey, null), (0, _defineProperty2["default"])(_id4, errorKey, error.message), (0, _defineProperty2["default"])(_id4, pendingKey, -1), _id4))))));
    });
  });
});
//# sourceMappingURL=reducers.spec.js.map