"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isTraitFetched = exports.isTraitFetching = exports.getTraitError = exports.getTraitData = exports.isSpecializationFetched = exports.isSpecializationFetching = exports.getSpecializationError = exports.getSpecializationData = exports.isSkillFetched = exports.isSkillFetching = exports.getSkillError = exports.getSkillData = exports.isItemFetched = exports.isItemFetching = exports.getItemError = exports.getItemData = void 0;

var _reReselect = _interopRequireDefault(require("re-reselect"));

var _constants = require("./constants");

var itemsPath = _constants.PATHS.ITEMS,
    skillsPath = _constants.PATHS.SKILLS,
    specializationsPath = _constants.PATHS.SPECIALIZATIONS,
    traitsPath = _constants.PATHS.TRAITS;
var dataKey = _constants.KEYS.DATA,
    errorKey = _constants.KEYS.ERROR,
    pendingKey = _constants.KEYS.PENDING;

var getData = function getData(_ref) {
  var data = _ref[dataKey];
  return data;
};

var getError = function getError(_ref2) {
  var error = _ref2[errorKey];
  return error;
};

var isFetching = function isFetching(_ref3) {
  var pending = _ref3[pendingKey];
  return pending > 0;
};

var isFetched = function isFetched(_ref4) {
  var data = _ref4[dataKey];
  return !!data;
};

var idCacheKey = function idCacheKey(state, _ref5) {
  var id = _ref5.id;
  return id;
};

var getItem = function getItem(_ref6, _ref7) {
  var items = _ref6[_constants.ROOT_REDUCER_KEY][itemsPath];
  var id = _ref7.id;
  return items[id] || {};
};

var getSkill = function getSkill(_ref8, _ref9) {
  var skills = _ref8[_constants.ROOT_REDUCER_KEY][skillsPath];
  var id = _ref9.id;
  return skills[id] || {};
};

var getSpecialization = function getSpecialization(_ref10, _ref11) {
  var specializations = _ref10[_constants.ROOT_REDUCER_KEY][specializationsPath];
  var id = _ref11.id;
  return specializations[id] || {};
};

var getTrait = function getTrait(_ref12, _ref13) {
  var traits = _ref12[_constants.ROOT_REDUCER_KEY][traitsPath];
  var id = _ref13.id;
  return traits[id] || {};
};

var getItemData = (0, _reReselect["default"])(getItem, getData)(idCacheKey);
exports.getItemData = getItemData;
var getItemError = (0, _reReselect["default"])(getItem, getError)(idCacheKey);
exports.getItemError = getItemError;
var isItemFetching = (0, _reReselect["default"])(getItem, isFetching)(idCacheKey);
exports.isItemFetching = isItemFetching;
var isItemFetched = (0, _reReselect["default"])(getItem, isFetched)(idCacheKey);
exports.isItemFetched = isItemFetched;
var getSkillData = (0, _reReselect["default"])(getSkill, getData)(idCacheKey);
exports.getSkillData = getSkillData;
var getSkillError = (0, _reReselect["default"])(getSkill, getError)(idCacheKey);
exports.getSkillError = getSkillError;
var isSkillFetching = (0, _reReselect["default"])(getSkill, isFetching)(idCacheKey);
exports.isSkillFetching = isSkillFetching;
var isSkillFetched = (0, _reReselect["default"])(getSkill, isFetched)(idCacheKey);
exports.isSkillFetched = isSkillFetched;
var getSpecializationData = (0, _reReselect["default"])(getSpecialization, getData)(idCacheKey);
exports.getSpecializationData = getSpecializationData;
var getSpecializationError = (0, _reReselect["default"])(getSpecialization, getError)(idCacheKey);
exports.getSpecializationError = getSpecializationError;
var isSpecializationFetching = (0, _reReselect["default"])(getSpecialization, isFetching)(idCacheKey);
exports.isSpecializationFetching = isSpecializationFetching;
var isSpecializationFetched = (0, _reReselect["default"])(getSpecialization, isFetched)(idCacheKey);
exports.isSpecializationFetched = isSpecializationFetched;
var getTraitData = (0, _reReselect["default"])(getTrait, getData)(idCacheKey);
exports.getTraitData = getTraitData;
var getTraitError = (0, _reReselect["default"])(getTrait, getError)(idCacheKey);
exports.getTraitError = getTraitError;
var isTraitFetching = (0, _reReselect["default"])(getTrait, isFetching)(idCacheKey);
exports.isTraitFetching = isTraitFetching;
var isTraitFetched = (0, _reReselect["default"])(getTrait, isFetched)(idCacheKey);
exports.isTraitFetched = isTraitFetched;
//# sourceMappingURL=selectors.js.map